#declare vitesse = 0; // 1 pour rendus rapide, 0 pour haute qualit
#declare tu= 0.2 ;       //turbulence 0.4
#declare o= 5 ;//octaves 3
#declare l= 4 ;         //lambda 1  
#declare tr = 1.4;
                      
#include "barque.inc"    
#include "feuille.inc" 
#include "fleurs.inc"   
#include "bouteille.inc"  
#include "banane.inc"                    
#include "chapeau.inc" 
#include "rameuse.inc"  

// **********************************************************************
// *********                sources de lumire            ***************
// ********************************************************************** 
#if (vitesse = 1)
//*************************lights pour rglages  
#declare lumiere = union {
light_source { <0, 40, 0> color < 1 , 1 , 1 >*0.3 }   
light_source { <-20, 40, 40> color < 1 , 1 , 1 > }
light_source { <20, 40, 40> color < 1 , 1 , 1 > } } 
#else     
//**************************lights pour rendus precis
#declare lumiere = light_source
{ <-20, 40, 40> color < 1 , 1 , 1 >*2
    area_light  <16, 0, 0> <0, 0, 16>  6, 6 adaptive 0   jitter    }      
#end
object {lumiere}
// *************************background
background { color <1.2,1.2,1.5>} 

// *************************************camras  
//camera { location  <-5, 7,0>   look_at   <0, 7,  0> }
//camra paysage
// camera {  location  <-1, 2.5,3>   look_at   <0, 1,  0> }
//camera portrait type photo
//camera {  location  <-1, 7,15>   look_at   <0, 0,  5> right <-10,0,-1>/sqrt(pow(10,2)+pow(1,2))*21/29.7} 
//camra portrait 1/3-2/3
//camera {  location  <-3, 8,14>   look_at   <0, 0, 4 > right <-10,0,-3>/sqrt(pow(10,2)+pow(3,2))*21/29.7 angle 45} 
//camera {  location  <-2, 8,15>   look_at   <0, 0, 5 > right <-10,0,-2>/sqrt(pow(10,2)+pow(2,2))*21/29.7 angle 40}
// portrait tlobj 
camera {  location  <-4, 16,30>   look_at   <0, 0, 2 > right <-28,0,-4>/sqrt(pow(28,2)+pow(4,2))*21/29.7 angle 20} 
//camra portrait 1/3-2/3 de plus haut
//camera {  location  <-3, 10,12>   look_at   <0, 0, 4 > right <-8,0,-3>/sqrt(pow(8,2)+pow(3,2))*21/29.7 angle 45} 
        

// **********************************************************************
// *********                 surface de l'eau             ***************
// **********************************************************************  
plane {  y,   -3 pigment {color rgb <80, 110, 80>/255  } }
// *********************** texture avec normal map 
#if (vitesse = 1 )  
#declare Quiet_Water =  material { texture {pigment { color rgb <80, 110, 80>/255   } }}
#else 
#declare Quiet_Water = material {  texture { pigment { color rgb <80, 110, 80>/255 //rgbt <40, 55, 40, 150>/255    //color rgbt <0.2, 0.3, 0.5, 0.218733>
                }
                normal { bump_map { png "water_hf.png"  map_type 0   interpolate 2   bump_size 20 } 
                rotate 90*x rotate 90*y translate <0.51,0,0.30>  scale <35,1,47>}   
         finish  {  ambient 0.1   diffuse 0.3    reflection 0.3   } }  }
#end
// *********************** surface
difference {
plane {  y,   -1 hollow on    } 
// creux d  la barque
torus { 1 , 0.4 rotate 90*z scale <4.8,4,7.9> translate <0,3,0>}  
material {Quiet_Water}}
#declare vitesse = 1;     
// ********************************murs du canal
box { < 22 , 15 , -100 >  < 25, -1 , 100 >  pigment {
image_map  { png "mur.png" map_type 0  interpolate 0 } rotate 90*y scale 20 } }

box { < -15 , 6 , -100 >  < -16, -1 , 100 > pigment { color < 0,0,0>}} 
                  
// **********************************************************************
// *********                       barque                 ***************
// ********************************************************************** 
object {barque} 
object {barque translate <17,0, -40>}                          
// **********************************************************************
// *********    disposition des objects dans la barque    ***************
// ********************************************************************** 
                           
// ********************************colliers de fleurs sur une palme
box { < -1.2 , 0.2 , 1 >  < 1.3 , -0.5 , 3.5 > pigment { color < 1 , 1 , 1 >*0.5 } translate <0,0,-1.0>}
object { feuille rotate -90*y scale <1.5,1.5,2.5> translate <0,0.25,2> } 
object {etal scale 0.08 rotate -87*x translate <0,0.4,2.5> }
 
// *********************************fleurs en pot
object {potdefleur scale 0.07 rotate 90*y      rotate -13*x translate <-0.4,1.0,7.5>}
object {potdefleur2 scale 0.07                 rotate -8*x translate <0.6,0.6,5.5>}  
object {potdefleur3 scale 0.07 rotate -90*y     rotate -5*x translate <-0.8,0.4,4.5>}  

// *********************************bouteilles d'eau
object {bouteille scale 0.4 rotate -100*x rotate -10*y            translate <0.9,0.7,7.9>} 
object {bouteille scale 0.4 rotate -90*z  rotate 45*y rotate -6*z translate <-1.3,0.4,6.7>}
object {bouteille scale 0.4 rotate -83*x  rotate -15*y  translate <-1.5,-0.35,-4>}

// *********************************regime de bananes
object {regime scale 0.3 rotate 90*y rotate -80*x rotate 20*y rotate 20*x translate <-0.8,0.2,-7>} 
                                          
// *********************************rameuse
object {rameuse scale 0.105*<-1,0.8,1> rotate -10*y translate <-0.3,0.7,-0.5> translate <0,0,-1.5>} 
object { chapeau scale 1.6*<1.2,0.8,1.2> rotate 10*z translate <-0.35,3.2,-1> translate <0,0,-1.5>}

// *********************************rame
cylinder { < 0 , 2.5 , 0 > , < 0 , -10 , 0 > , 0.07
texture {bois scale <1, 3/0.75,1> translate <5,-3,0> }
rotate -77.5*z //-78.5
rotate -19.7*y //-20.7
translate <0,0.72,-2.45> }                                
                              /*
object {feuillemorte scale 0.15 rotate 70*y translate <-4,-1.25,-30> } 
object {feuillemorte scale 0.15 rotate 150*y translate <8,-1.25,-25> }
object {feuillemorte scale 0.15 rotate 30*y translate <11,-1.25,-22> }
object {feuillemorte scale 0.15 rotate 00*y translate <0,-1.25,-21> }  
object {feuillemorte scale 0.15 rotate 150*y translate <4,-1.25,-20> }
object {feuillemorte scale 0.15 rotate 120*y translate <-5,-1.25,-18> } 
object {feuillemorte scale 0.15 rotate 30*y translate <10,-1.25,-15> }  
object {feuillemorte scale 0.15 rotate 50*y translate <-3,-1.25,-10> } 
object {feuillemorte scale 0.15 rotate 110*y translate <4,-1.25,-8> }
object {feuillemorte scale 0.15 rotate 110*y translate <-4,-1.25,-4> } 
object {feuillemorte scale 0.15 rotate 110*y translate <5,-1.25,0> }
object {feuillemorte scale 0.15 rotate 10*y translate <3,-1.25,3> } 
object {feuillemorte scale 0.15 rotate 30*y translate <-3,-1.25,1> } 
object {feuillemorte scale 0.15 rotate 80*y translate <-4,-1.25,6> }
object {feuillemorte scale 0.15 rotate 70*y translate <4,-1.25,8> } 
object {feuillemorte scale 0.15 rotate 150*y translate <3,-1.25,10> } 
object {feuillemorte scale 0.15 rotate 50*y translate <-4,-1.25,11> }
                                  */
  